<!--- 
|| LEGAL ||
$Copyright: Andrew Spencer 2005 $
$License: Released Under the "Common Public License 1.0", http://www.opensource.org/licenses/cpl.php$

|| VERSION CONTROL ||

$Author: Andrew Spencer$
$Date: 2005/09/26 09:13:14 $
$Name: ruleMenuList $
$Revision: 0.9 $

|| DESCRIPTION || 
$Description: Dynamic Menu building rule for simple tree, sitemap, horizontal, and vertical menu panes based on cross-browser supportable javascript and list-item notation. $
$TODO: There is a cludge that prevents all selected items from appearing in your menu IF you choose items in very different spots in the site architecture, so try to keep your selections "nearby"... or help me fix the code :) $

|| DEVELOPER ||
$Developer: Andrew Spencer (tokensdragon@hotmail.com) $
--->




<cfcomponent displayname="Dynamic Menu Builder Rule" extends="farcry.farcry_core.packages.rules.rules" bCustomRule="1" hint="Selectable Navigation aid.  Creates either a list-style menu (vertical or horizontal) or a dropdown menu." >
	<cfproperty name="homeObjectID" type="UUID" hint="Top Level Menu Location" required="yes" default="">
	<cfproperty name="SelectedObjectIDs" type="longchar" hint="The Items that Constitute the Menu" required="no" default="">
	<cfproperty name="class" type="string" hint="Menu Style to Inherit" required="no" default="">
	<cfproperty name="id" type="string" hint="Menu CSS ID to Inherit (defaults to 'nav')" required="no" default="">
	<cfproperty name="displayMethod" type="string" hint="Display method to render the menu rule with." required="yes" default="displayMenu">
	<cfproperty name="displayOption" type="string" hint="Variations in the Display Method (use 'DropDown' to create collapsible menu)" required="no" default="DropDown">
	<cfproperty name="depth" type="string" hint="Depth of Number of Sub-menus to render" required="no" default="all">
			
		<cfscript>
		// get navigation elements to root
			function getChildren(parentID)
			{
				navFilter=arrayNew(1);
				navfilter[1]="status IN (#listQualify(request.mode.lvalidstatus, "'")#)";
				// ' !reset colour marking in DW
				qNav = application.factory.oTree.getDescendants(objectid=parentID, depth=1, afilter=navFilter);
				return qNav;
			}
		</cfscript>
	
	

	<cffunction name="execute" access="public" displayname="afMenuList Renderer" description="I output the menu to the screen based on your parameters.">
		<cfargument name="ObjectID" required="yes" default="#application.navid.root#" type="uuid">
		
			<cfset var stObj = this.getData(arguments.objectid)>
			<cfset var dropdown_prefix = "#stObj.id#">
			<cfif stObj.displayOption eq "DropDownVertical">
				<cfset dropdown_prefix = "Vdrop_#stObj.id#">
			<cfelseif stObj.displayOption eq "DropDownHorizontal">
				<cfset dropdown_prefix = "Hdrop_#stObj.id#">
			<cfelseif stObj.displayOption eq "DropDownSideCar">
				<cfset dropdown_prefix = "Sdrop_#stObj.id#">
			</cfif>
			<!--- drop in any required includes here... --->
			<cfif findnocase("DropDown", stObj.displayOption)>
				<cfoutput>
					<script type="text/javascript"><!--//--><![CDATA[//><!--
					sfHover = function() {
						var sfEls = document.getElementById("#dropdown_prefix#").getElementsByTagName("LI");
						for (var i=0; i<sfEls.length; i++) {
							sfEls[i].onmouseover=function() {
								this.className+=" sfhover";
							}
							sfEls[i].onmouseout=function() {
							this.className=this.className.replace(new RegExp(' sfhover\\b'), '');
							}
							
						}
					}
					if (window.attachEvent) window.attachEvent("onload", sfHover);
					
					//--><!]]></script>
				</cfoutput>
			</cfif>
			<!---<cfdump var="#stObj#">--->
			<!--- run the afgenMenu function using set parameters --->
				<cfoutput><style></cfoutput>
					<cfinclude template="ruleMenuList/dyna_CSS.cfm">
				<cfoutput></style></cfoutput>
				<cfif len(StObj.Class) gt 0><Cfoutput><div class="#StObj.Class#"><div class="#StObj.Class#_title">#stObj.Label#</div></cfoutput></cfif>
				<cfoutput>#af_genMenu(parentID=stObj.HomeObjectID, depth=stObj.depth, id=dropdown_prefix, selectedObjectIDs=stObj.selectedObjectIDs, displayMethod=stObj.displayMethod, displayOption=stObj.displayOption)#</cfoutput>
				<cfif len(StObj.Class) gt 0></div></cfif>
	</cffunction>

	
	<cffunction name="af_genMenu" access="private" displayname="afMenuList Renderer" description="I output the menu to the screen based on your parameters." output="yes">
		<cfargument name="parentID" required="no" type="uuid" default="#application.navid.root#" >
		<cfargument name="class" required="no" type="string" default="">
		<cfargument name="id" required="no" type="string" default="">
		<cfargument name="selectedObjectIDs" type="string" hint="Currently Selected Objects" required="no" default="">
		<cfargument name="displayMethod" type="string" hint="Display method to render the menu rule with." required="no" default="display">
		<cfargument name="displayOption" type="string" hint="Variations in the Display Method (use 'DropDown' to create collapsible menu)" required="no" default="">
		<cfargument name="depth" type="string" required="no" default="all">
		
								<cfset Var menu_counter = 1>
								<cfset Var menuPrefix = "men">	
								<cfset var current_menu_id = "">
								
								
		<cfimport taglib="/farcry/farcry_core/tags/webskin" prefix="skin">
			
		<cfset variables.qNav = getChildren(arguments.parentID)>
		<!---<cfdump var="#variables.qNav#">--->
		<cfsavecontent variable="variables.genMenu">
		
			<cfswitch expression="#arguments.displayMethod#">
				<cfcase value="display">
				

					<cfoutput><ul <cfif len(arguments.class) gt 0>class="#arguments.class#"</cfif> <cfif len(arguments.id) gt 0>id="#arguments.id#"</cfif>></cfoutput>
								<cfloop query="qNav">
										<cfset variables.qNav_child = getChildren(objectID)>
														<cfif variables.qNav_child.recordcount gt 0>
															<cfif listfindnocase(selectedObjectIDs, objectID)><cfoutput><li></cfoutput><skin:buildLink objectid="#objectID#" class="daddy"><cfoutput>#objectname# </cfoutput></skin:buildLink>
																<cfif isnumeric(arguments.depth)>
																	<cfset arguments.depth = arguments.depth-1>
																</cfif>
																<cfif arguments.depth eq "all" or arguments.depth gt 0>
																	<cfoutput>#af_genMenu(parentID=objectID, depth=arguments.depth, class=arguments.class, selectedObjectIDs=arguments.selectedObjectIDs, displayMethod=arguments.displayMethod, displayOption=arguments.displayOption)#</cfoutput>
																</cfif>
																<cfoutput></li></cfoutput>
															</cfif>
														<cfelse>
															<cfif listfindnocase(selectedObjectIDs, objectID)><cfoutput><li></cfoutput><skin:buildLink objectid="#objectID#"><cfoutput>#objectname#</cfoutput></skin:buildLink><cfoutput></li></cfoutput></cfif>
														</cfif>
											
								</cfloop>
					<Cfoutput></ul></Cfoutput>
				</cfcase>
				
				<cfcase value="form">
					<cfoutput><ul <cfif arguments.parentID eq application.navid.root>id="menu1" class="tree-menu"</cfif>></cfoutput>
								
									
								
								
								<cfif len(arguments.displayOption) gt 0 and left(arguments.displayOption, 3) eq menuPrefix>
									<cfset menuPrefix = "#arguments.displayOption#_">
								</cfif>
								
								
								
								<cfloop query="qNav">	
								
										<Cfset current_menu_id = "#menuPrefix##menu_counter#">
										<cfset variables.qNav_child = getChildren(objectID)>
											
										 				
															<cfif variables.qNav_child.recordcount gt 0>
																<cfoutput><input type="checkbox" value="#objectID#" name="#current_menu_id#" class="menu_item" onClick="toggle_nested(this.form, this.name);" <cfif listfindnocase(arguments.selectedObjectIDs, objectID)>checked</cfif> /><li><a href="javascript:void(0);">#objectname#</a>
																
																		#af_genMenu(parentID=objectID, class=arguments.class, selectedObjectIDs=arguments.selectedObjectIDs, displayMethod=arguments.displayMethod, displayOption=current_menu_id)#</li></cfoutput>
															<cfelse>
																<cfoutput><input type="checkbox" value="#objectID#" name="#current_menu_id#" class="menu_item" <cfif listfindnocase(arguments.selectedObjectIDs, objectID)>checked</cfif>/><li><a href="javascript:void(0);">#objectname#</a></li></cfoutput>
															</cfif>
												
										<cfset menu_counter = menu_counter + 1>
								
								</cfloop>
					<cfoutput></ul></cfoutput>

				</cfcase>
				
			</cfswitch>
	
		</Cfsavecontent>
		<cfreturn variables.genMenu>
		
	</cffunction>


	<cffunction name="displayForm" returntype="string" output="yes">
		<cfargument name="parentID" required="no" default="#application.navid.root#" type="uuid">
		<cfargument name="depth" required="no" default="all">
		<cfargument name="class" required="no" default="tree-menu" hint="tree-menu is the default and functional click-to-open style, but you can modify if needed.">
		<cfargument name="id" required="no" default="menu1">
		<cfargument name="selectedObjectIDs" type="string" hint="Currently Selected Objects" required="no" default="">
		<cfargument name="displayMethod" type="string" hint="Display method to render the menu rule with." required="no" default="form">
		<cfargument name="displayOption" type="string" hint="Variations in the Display Method (use 'DropDown' to create collapsible menu)" required="no" default="">
		
		
		
		
			<cfoutput>
				<!--- drop in any required includes here... --->
		
				
					<script language="javascript">
					
						<cfinclude template="ruleMenuList/TreeMenu.js">
						
					</script>		
					<style>
						<Cfinclude template="ruleMenuList/TreeMenu.css">
					</style>
					
				<script language="javascript">
					<cfinclude template="ruleMenuList/TreeMenuCheckbox.js">	
				</script>										
				<!--- run the afgenMenu function using set parameters --->
				#af_genMenu(parentID=arguments.parentID, depth=arguments.depth, class=arguments.class, selectedObjectIDs=arguments.selectedObjectIDs, displayMethod=arguments.displayMethod)#
			</cfoutput>
				
		
	
	
	</cffunction>


	<cffunction name="update" access="public">
		<cfargument name="ObjectID" type="UUID" hint="Menu Identifier" required="yes">
		<cfargument name="Label" type="string" hint="Optional Text Label" required="no" default="">
		
		
		<cfimport taglib="/farcry/fourq/tags/" prefix="q4">
		<cfimport taglib="/farcry/farcry_core/tags/navajo/" prefix="nj">
        <cfimport taglib="/farcry/farcry_core/tags/display/" prefix="display">
		
		
		
		<cfparam name="isClosed" default="yes">
        <cfif isDefined("form.apply")>
            <cfset isClosed = "No">
        </cfif>
	<!---<cfdump var="#form#">--->
		<cfset stObj = this.getData(arguments.objectid)>
		<cfif isDefined("form.updateRuleMenuList")>
			<cfscript>
				stObj.objectID = form.objectID;
				stObj.class = form.class;
				stObj.depth = form.depth;
				stObj.id = form.id;
				stObj.label = form.label;
				stObj.displayMethod = form.displayMethod;
				stObj.displayOption = form.displayOption;
				
				
				
			</cfscript>
			
			<cfif listcontainsnocase(form.fieldnames, "men")>
				<cfset stObj.selectedObjectIDs = "">
				<cfloop list="#form.fieldnames#" index="i">
					<cfif findnocase("men", left(i, 3))>
						<cfset stObj.selectedObjectIDs = listappend(stObj.selectedObjectIDs, evaluate("form." & i))>
					</cfif>
					<!--- hack for argument inclusion listfirst(stObj.selectedObjectIDs)--->

				</cfloop>
				<cfset parent_return = application.factory.oTree.getParentID(objectid=listfirst(stObj.selectedObjectIDs))>
					<cfset stObj.homeObjectID = #valuelist(parent_return.parentid)#>
			<cfelse>
				<cfset stObj.homeObjectID = "">
				<cfset stObj.selectedObjectIDs = "">
			</cfif>
			<q4:contentobjectdata typename="#application.rules.ruleMenuList.rulePath#" stProperties="#stObj#" objectID="#stObj.objectID#">
			
			<!--- Now assign the metadata --->		
			<cfset message = "#application.adminBundle[session.dmProfile.locale].updateSuccessful#">
		</cfif>
				
		<cfif isDefined("message")>
			<cfoutput><div align="center"><strong>#message#</strong></div><br>
<br>
</cfoutput>
		</cfif>
		
<!--- need some code to fix the multitude of form elements into one package --->
			
			<cfif stObj.homeObjectID eq "home" or len(stObj.homeObjectID) eq 0><cfset stObj.homeObjectID = #application.navid.home#></cfif>
			<cfscript>
			form.objectID = stObj.ObjectID;
			form.class = stObj.class;
			form.depth = stObj.depth;
			form.id = stObj.id;
			form.label = stObj.label;
			form.displayOption = stObj.displayOption;
			
			form.homeObjectID = stObj.homeObjectID;
			</cfscript>	
			<!---<cfdump var="#stObj#">--->
		<cfoutput>
		<script language="JavaScript">
			function check_menuItems(form) {
				var oInp = document.getElementsByTagName('input');
				var oCheck = new Array();
				var j=0;
				for(var i=0;i<oInp.length;i++){
					if(oInp[i].getAttribute('type')=='checkbox' ){
						oCheck[j] = oInp[i];j++;
					}

				}
				for (i=1;i<oCheck.length;i+=1){
  					if (oCheck[i].checked == true)
					{
  						return 'valid';
					}
 				}

			}
			
			
		</script>
		<!---<cfdump var="#stObj#">--->
			<form action="" method="post" 	>	
			<input type="hidden" value="#form.HomeObjectID#" name="homeObjectID">
			<input type="hidden" value="#form.ObjectID#" name="ObjectID">
			<input type="hidden" name="displayMethod" value="display">
			<table align="center" border="0" width=50%>
				
			
				<tr>
				<td valign="top"><strong>Menu Display Type:</strong> <br>

				<select name="DisplayOption">
					<option value="DropDownHorizontal" <cfif form.DisplayOption eq "DropDownHorizontal">selected</cfif>>Horizontal Drop Down</option>
					<option value="DropDownVertical" <cfif form.DisplayOption eq "DropDownVertical">selected</cfif>>Vertical Drop Down</option>
					<option value="DropDownSideCar" <cfif form.DisplayOption eq "DropDownSideCar">selected</cfif>>Menu for Float or Side Column</option>
					<option value="SiteMap" <cfif form.DisplayOption eq "SiteMap">selected</cfif>>Site Map</option>
					<option value="Tree" <cfif form.DisplayOption eq "Tree">selected</cfif>>Collapsing Tree</option>
				</select>
				</td>
				<td valign="top"><strong>Optional Description:</strong><br><input type="text" name="label" value="#form.label#"><br>
<br><br>


					</td>	
			</tr>
			<tr>
				<td colspan=2><strong>Site Architecture: </strong><br>
Select the Navigation Items you wish to include in this Menu.  Note: some selections of individual nodes deep within a structure may prevent those menu items from displaying properly, in general please choose items within a related section of the site structure.<br><br>


					#displayForm(parentID=application.navid.root, class=stObj.class, selectedObjectIDs=stObj.selectedObjectIDs)#
				</td>
			</tr>				
			</table>
			
			<display:OpenLayer  title="Advanced Options" titleFont="Verdana" titleSize="7.5" isClosed="#isClosed#" border="no">
			<table align="center" width="50%" border="0">	
				<tr>
						<td valign="bottom"><strong>Optional Style Class</strong><br>
									<input type="text" name="class" value="#form.class#"></td>
						<td valign="bottom"><strong>Optional Style ID <br>
(This must be unique per drop-down menu shown)</strong><br>
										<input type="text" name="id" value="#form.id#">
						</td>
					</tr>
					<tr>
						<td colspan=2><b>Maximum Number of Submenu Levels (Depth)</b><br>

											<select name="depth">
											<option value="all" <cfif form.depth eq "all">selected</cfif>>Show All</option>
												<cfloop from=1 to=5 index="i">
													<option value="#i#" <cfif form.depth eq i>selected</cfif>>#i#</option>
												</cfloop>
											</select>
						</td>
					</tr>
			</table>	
			</display:OpenLayer>
			<input type="hidden" name="UpdateRuleMenuList" value="Sent">
			<div align="center"><input class="normalbttnstyle" type="button" value="#application.adminBundle[session.dmProfile.locale].go#" name="updateRuleMenuList" onclick="if(check_menuItems(this.form) == 'valid'){this.form.submit();}else{alert('You cannot create an Empty Menu.  Please Select Menu Items from the Site Architecture.');}"></div>
			</form>
		</cfoutput>
	</cffunction>

	
</cfcomponent>